`medianfilter` <-
function(matrix, mask=25, l=NULL, u=NULL, quantile=FALSE) {
	if(is.matrix(matrix) && mask > 0 && ((is.numeric(l) && is.numeric(u)) | (!is.numeric(l) && !is.numeric(u))) && is.logical(quantile))   {
		d<-dim(matrix)
		matnew<-matrix*0
		for( i in 1:d[1]){
			for(j in 1:d[2]){
				matnew[i,j]<-median(matrix[max(c(1,i-mask)):min(c(d[1],i+mask)),
									max(c(1,j-mask)):min(c(d[2],j+mask))])
			}

		}
		mxx<-matrix-matnew
		if(!is.numeric(l) && !is.numeric(u) && quantile)   {
			l<-quantile(mxx,0.0001)
			u<-quantile(mxx,0.9999)
		}  else if(!is.numeric(l) && !is.numeric(u) && !quantile)   {
			l<-min(mxx)
			u<-max(mxx)
		}   else if(is.numeric(l) && is.numeric(u) && quantile)   {
			warning("parameter \"quantile = TRUE\" is ignored")
		}
		return(round(((mxx-l)/(u-l))*255, 0))
	}   else   {
		warning("invalid parameters\n")
		return(c(0))
	}
}

